EnvironmentProbe = class()

function EnvironmentProbe:init(entity, size, mask)
    self.entity = entity
    
    self.size = size
    
    self.camera = self.entity:add(craft.camera, 90, 0.1, 100, false)
    self.camera.mask = mask or ~0
    self.entity.active = false
    
    -- Create HDR cubemap + render target
    self.cubeMap = craft.cubeTexture(size, true)
    self.cubeMapIrradiance = craft.cubeTexture(size, true)
    self.target = craft.renderTarget(self.cubeMap)
end

local ENV_PROBE_VECTORS =
{
    {vec3(1,0,0), vec3(0,1,0)},
    {vec3(-1,0,0), vec3(0,1,0)},
    {vec3(0,-1,0), vec3(0,0,-1)},
    {vec3(0,1,0), vec3(0,0,1)},
    {vec3(0,0,-1), vec3(0,1,0)},
    {vec3(0,0,1), vec3(0,1,0)}
}

function EnvironmentProbe:render(iterations)
    for index, vectors in pairs(ENV_PROBE_VECTORS) do
        local forward, up = table.unpack(vectors)
        self.entity.rotation = quat.lookRotation(forward, up)
        self.camera:draw(self.target, index)
    end
    self.cubeMap:generateMipmaps()
    
    return self.cubeMap:generateIrradiance(self.cubeMapIrradiance, iterations or 1024)
end