function setup()
    scene = craft.scene()
    
    probeEnt = scene:entity()
    probe = probeEnt:add(EnvironmentProbe, 512)
    
    scene.sky.material = craft.material(asset.builtin.Materials.Atmosphere)
    
    scene.environment = probe:render()
        
    scene.camera:add(OrbitViewer, vec3(0,0,0), 10, 0, 50)
    scene.camera:get(OrbitViewer).rx = 45
    scene.camera:get(OrbitViewer).ry = 220
    
    cube = scene:entity()
    cube.model = craft.model.icosphere(1.0, 5)
    cube.material = craft.material(asset.builtin.Materials.Standard)
    cube.material.roughness = 0
    cube.material.metalness = 1
    --cube.material.envMap = craft.cubeTexture(asset.documents.HDR_029_Sky_Cloudy_Bg)
end

function draw()
    scene:draw()
    scene:update(DeltaTime)
end

function touched(touch)
    scene.camera:get(OrbitViewer):touched(touch)
end